您的位置:首页 > 理论基础 > 计算机网络

hdu 5438 Ponds(长春网络赛 拓扑+bfs)

2015-09-21 19:48 716 查看
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5438

Ponds

Time Limit: 1500/1000 MS (Java/Others) Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 2237 Accepted Submission(s): 707


[align=left]Problem Description[/align]
Betty owns a lot of ponds, some of them are connected with other ponds by pipes, and there will not be more than one pipe between two ponds. Each pond has a value v.

Now Betty wants to remove some ponds because she does not have enough money. But each time when she removes a pond, she can only remove the ponds which are connected with less than two ponds, or the pond will explode.

Note that Betty should keep removing ponds until no more ponds can be removed. After that, please help her calculate the sum of the value for each connected component consisting of a odd number of ponds

[align=left]Input[/align]
The first line of input will contain a number T(1≤T≤30) which is the number of test cases.

For each test case, the first line contains two number separated by a blank. One is the number p(1≤p≤104) which represents the number of ponds she owns, and the other is the number m(1≤m≤105) which represents the number of pipes.

The next line contains p numbers v1,...,vp, where vi(1≤vi≤108) indicating the value of pond i.

Each of the last m lines contain two numbers a and b, which indicates that pond a and pond b are connected by a pipe.

[align=left]Output[/align]
For each test case, output the sum of the value of all connected components consisting of odd number of ponds after removing all the ponds connected with less than two pipes.

[align=left]Sample Input[/align]

1

7 7
1 2 3 4 5 6 7

1 4
1 5

4 5

2 3
2 6

3 6
2 7

[align=left]Sample Output[/align]

21

[align=left]Source[/align]
2015 ACM/ICPC Asia Regional Changchun Online

题目大意:有一些池塘,每一个池塘都有一个价值,现在想删除一些池塘。
有如下删除条件:1、一个池塘有两个管道连接的不可以删除。
2、求最后剩下的为奇数环的池塘的价值。

解题思路:用拓扑将所有入度为0和1的点都可以删掉,直到删完为止。在一个点一个点搜过去,判断环中是否为奇数个池塘。如果可以就return和,否则就不加,return0即可。

详见代码。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>

using namespace std;
#define ll long long
const int N=10010;

ll p,m,v
,vis
,indir
;
vector<ll>G
;

ll bfs(ll x)
{
queue<ll>q;
q.push(x);
vis[x]=1;
ll k=0;
ll sum=v[x];
while (!q.empty())
{

int s=q.front();
q.pop(); //cout<<s<<endl;
k++;
for (int i=0; i<G[s].size(); i++)
{
if (!vis[G[s][i]]&&indir[G[s][i]]>=2)//删掉的点不可以加进来
{
sum+=v[G[s][i]];
q.push(G[s][i]);
vis[G[s][i]]=1;
}
}
}
if (k>=3&&k%2==1)
return sum;
else
return 0;
}

int main()
{
int T,a,b;
scanf("%d",&T);
while (T--)
{
scanf("%lld%lld",&p,&m);
memset(vis,0,sizeof(vis));
memset(G,0,sizeof(G));
memset(indir,0,sizeof(indir));
for (int i=1; i<=p; i++)
{
scanf("%lld",&v[i]);
}
for (int i=1; i<=p; i++)
G[i].clear();
for (int i=1; i<=m; i++)
{
scanf("%d%d",&a,&b);
G[a].push_back(b);//将b放在a队列的最后一个
G[b].push_back(a);
indir[a]++;
indir[b]++;
}
int j;
for (int i=1; i<=p; i++)
{
for ( j=1; j<=p; j++)
{
if (indir[j]==0||indir[j]==1)
{
break;
}
}
if (j>p)
break;
indir[j]=-1;
for (int k=0; k<G[j].size(); k++)
{
indir[G[j][k]]--;
}
}
ll ans=0;
for (int i=1; i<=p; i++)//搜遍所有的环
if (!vis[i]&&indir[i]>=2)
ans+=bfs(i);
cout<<ans<<endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: